// C}bv̏̌oH_CNXg@vZŋ߂邽߂̃NX


#pragma once
#include <list>
#include <math.h>
#include <windows.h>

#define Circle_r 1	//`Å

struct Node;
struct NodeConnect;

//m[h
struct Node
{
	int iCastleID;
	int GetCastleID() {
		return iCastleID;
	}

	int x;//m[h̍W
	int y;

	std::list<NodeConnect> m_connectNode;	//ڑĂm[h

	//vZŕێl-------------------
	int		cost;	//TɗvRXgB-1̎͂̃m[h𖢒TƂĂ܂B
	Node*	toGoal;	//S[ւ̍ŒZ[gɂȂm[h
	//-----------------------------------


	Node(int iCastleID, int ix, int iy);

	//vZʂNA
	void Reset();

	//m[hւ̐ڑ폜
	void RemoveConnect(Node* n);
};

//m[hԂ̃RXgvZ(ł͋RXgƂ܂)
double QueryCost(Node* n1, Node* n2 );

//̃m[hւ̐ڑ
struct NodeConnect
{
	Node*		node;//ړm[h
	int			cost;//ړɂRXg(ł͋)

	NodeConnect( Node*	_node, int _cost )
	{
		node = _node;
		cost = _cost;
	}
};

struct NodePair
{
	Node* n1;
	Node* n2;
};

//_CNXg@ōŒZoH߂NX
class Dijkstra
{
	Node* m_start;
	Node* m_goal;
	std::list<Node*> m_node;

	//m[hXg̉Ԗڂ 0X^[g Ƃ-1
	int QueryIdx( Node* node );
	//CfbNXwŃXgm[h擾
	Node* QueryFromIdx(int idx);

public:
	Dijkstra();
	virtual ~Dijkstra();

	//Sm[h폜
	void Clear();

	void AddNode(int iCastleID, int x, int y)
	{
		m_node.push_back( new Node(iCastleID, x,y) );
	}
	
	//wm[h폜
	void Remove( Node* n1 );
	//wm[hڑ폜
	void RemoveConnect( Node* n1, Node* n2 );

	//Q_Ԃ̃[g쐬
	void ConnectNode( Node* n1, Node* n2 );

	//NbNʒũm[h擾
	Node* Query(int x, int y);

	// ԍm[h擾
	Node* Query(int iCastleID);

	//NbNʒu̐ɏm[hg擾
	bool QueryLineOnNodePair(NodePair* rslt, int x, int y);

	//em[hZbg
	void ResetNode();

	//[gJn
	void SearchRoot();

	//X^[g_
	void SelctStart(Node* node) {
		m_start	= node;
	}
	void SelctGoal(Node* node) {
		m_goal	= node;
	}

	Node* GetStartNode() {
		return m_start;
	}

	Node* GetGoalNode() {
		return m_goal;
	}

	//`
	void Draw(HDC hdc);

	//t@Cǂݍ݁A
	bool Inport();

};
