#include "GameDataStruct.h"

// ɕ߂ɁATENSHOU.EXẼ|C^z񂩂悤ɂA҂̉ւ̑ϋv͂B
static char nb6CastleTypeName[GAMEDATASTRUCT_CASTLETYPE_NUM][5] = {
	"",
	"V",
	"",
	"䏊",
	"",
	"",
	""
};

// ̃^CvID̓Iȕ𓾂
char *getCastleTypeName(int iCastleType) {
	if (iCastleType == 0x00) {
		return nb6CastleTypeName[0];
	}
	else if (iCastleType == 0x01) {
		return nb6CastleTypeName[1];
	}
	else if (iCastleType == 0x02) {
		return nb6CastleTypeName[2];
	}
	else if (iCastleType == 0x04) {
		return nb6CastleTypeName[3];
	}
	else if (iCastleType == 0x08) {
		return nb6CastleTypeName[4];
	}
	else if (iCastleType == 0x10) {
		return nb6CastleTypeName[5];
	}
	else if (iCastleType == 0x20) {
		return nb6CastleTypeName[6];
	}
	return "";
}


// w̌RcĂ̐B
int getGundanHasCastleNum(int iGundanID) {
	int iHasCastleCnt = 0;
	if (0 <= iGundanID && iGundanID < GAMEDATASTRUCT_GUNDAN_NUM) {
		for (int iCastleID = 0; iCastleID < GAMEDATASTRUCT_CASTLE_NUM; iCastleID++) {
			// Rcԍv̂JEg
			if (iGundanID == nb6castle[iCastleID].attach - 1) {
				iHasCastleCnt++;
			}
		}
	}
	return iHasCastleCnt;
}

// w̑喼Ă̐B
int getDaimyoHasCastleNum(int iDaimyoID) {
	int iHasCastleCnt = 0;

	if (0 <= iDaimyoID && iDaimyoID < GAMEDATASTRUCT_DAIMYO_NUM) {
		for (int iCastleID = 0; iCastleID < GAMEDATASTRUCT_CASTLE_NUM; iCastleID++) {
			int iGundanID = nb6castle[iCastleID].attach - 1;

			if (0 <= iGundanID && iGundanID < GAMEDATASTRUCT_GUNDAN_NUM) {
				// 喼ԍv̂JEg
				if (iDaimyoID == nb6gundan[iGundanID].attach - 1) {
					iHasCastleCnt++;
				}
			}
		}
	}
	return iHasCastleCnt;
}


// ɏ镺𓾂
int getCastleHeisuCnt(int iCastleID) {
	int iSoldierCnt = 0;
	for (int i = 0; i<GAMEDATASTRUCT_BUSHOU_NUM; i++) {
		if (nb6bushou[i].castle - 1 == iCastleID) {
			if (nb6bushouname[i].State <= 2) { // 喼, Rc,  ŃJEg
				iSoldierCnt += nb6bushou[i].soldier;
			}
		}
	}
	return iSoldierCnt;
}





//--------------MAIÑObhn

// Obh|WVNX
GRID_POSITION::GRID_POSITION(int _x, int _y) {
	x = _x,
		y = _y;

	// eאڏ͖Ԃŏ
	nw = 0xFFFF;
	no = 0xFFFF;
	ne = 0xFFFF;
	we = 0xFFFF;
	ea = 0xFFFF;
	sw = 0xFFFF;
	so = 0xFFFF;
	se = 0xFFFF;

}

// ObhWǔZBW`WãxNg߂̂ɁAʏAa|`邾낤B
GRID_VECTOR operator-(GRID_POSITION &p1, GRID_POSITION &p2) {
	GRID_VECTOR p;
	p.x = p1.x - p2.x;
	p.y = p1.y - p2.y;
	return p;
}

// hcACObh̃|WV𓾂BObh0,0Bmapdataobgk̃Obh΂킩₷B
// P̃Obhɂ́AP̏邵ȂB
GRID_POSITION getCastlePosInMainGrid(int iCastleID) {
	GRID_POSITION pos(0, 0);
	if (0 <= iCastleID && iCastleID < GAMEDATASTRUCT_CASTLE_NUM) {
		int iGridX = (nb6castlemax[iCastleID].x + 1) / 5; // OIWȂ̂Ł{PĂTŊBw͂P̃Obh̒ɂT̏ꏊB
		int iGridY = (nb6castlemax[iCastleID].y + 1) / 3; // OIWȂ̂Ł{PĂRŊBx͂P̃Obh̒ɂR̏ꏊB

		pos.x = iGridX;
		pos.y = iGridY;

		// אڂ̂hcĂB
		for (int iCastleID = 0; iCastleID < GAMEDATASTRUCT_CASTLE_NUM; iCastleID++) {
			int iFX = (nb6castlemax[iCastleID].x + 1) / 5; // OIWȂ̂Ł{PĂTŊBw͂P̃Obh̒ɂT̏ꏊB
			int iFY = (nb6castlemax[iCastleID].y + 1) / 3; // OIWȂ̂Ł{PĂRŊBx͂P̃Obh̒ɂR̏ꏊB

			if (iFX - pos.x == -1 && iFY - pos.y == -1) { // k
				pos.nw = iCastleID + 1;
			}
			else if (iFX - pos.x == 0 && iFY - pos.y == -1) { // k
				pos.no = iCastleID + 1;
			}
			else if (iFX - pos.x == 1 && iFY - pos.y == -1) { // k
				pos.ne = iCastleID + 1;
			}
			else if (iFX - pos.x == -1 && iFY - pos.y == 0) { // 
				pos.we = iCastleID + 1;
			}
			else if (iFX - pos.x == 1 && iFY - pos.y == 0) { // 
				pos.ea = iCastleID + 1;
			}
			else if (iFX - pos.x == -1 && iFY - pos.y == 1) { // 쐼
				pos.sw = iCastleID + 1;
			}
			else if (iFX - pos.x == 0 && iFY - pos.y == 1) { // 
				pos.so = iCastleID + 1;
			}
			else if (iFX - pos.x == 1 && iFY - pos.y == 1) { // 쓌
				pos.se = iCastleID + 1;
			}
		}

		return pos;
	}
	return pos;
}

// w̏ɑ΂ėאڂẴXg𓾂
vector<int> getRinsetsuCastles(int iCastleID) {
	// ܂́Aw̃Obh̏ꏊ𓾂
	GRID_POSITION CenterPos = getCastlePosInMainGrid(iCastleID);

	vector<int> RinsetsuCastles;

	// אڂĂxNgɒǉĂ䂭
	for (int iTargetID = 0; iTargetID < GAMEDATASTRUCT_CASTLE_NUM; iTargetID++) {
		// g̓pX
		if (iCastleID == iTargetID) {
			continue;
		}

		GRID_POSITION TargetPos = getCastlePosInMainGrid(iTargetID);
		// אڂĂB
		if (abs(CenterPos.x - TargetPos.x) <= 1 && abs(CenterPos.y - TargetPos.y) <= 1) {
			RinsetsuCastles.push_back(iTargetID);
		}
	}
	return RinsetsuCastles;
}

