#include <algorithm>
#include "GameDataStruct.h"

using namespace std;


// Ƃ喼͂̓RcԍXg𓾂B
vector<int> getGovernedGundanList(int iDaimyoID) {
	// ȊO͉ꂸɕԂB
	vector<int> list;

	if (0 <= iDaimyoID && iDaimyoID < GAMEDATASTRUCT_DAIMYO_NUM) {

		// Y̑喼hcɑRcXgɉ
		for (int iGundanID = 0; iGundanID<GAMEDATASTRUCT_GUNDAN_NUM; iGundanID++) {
			if (nb6gundan[iGundanID].attach - 1 == iDaimyoID) {
				list.push_back(iGundanID);
			}
		}
	}

	return list;
}

// Rcɏ镐Xg𓾂
vector<int> getGundanBushouList(int iGundanID) {
	// ȊO͉ꂸɕԂB
	vector<int> list;

	for (int i = 0; i<GAMEDATASTRUCT_BUSHOU_NUM; i++) {
		if (nb6bushou[i].gundan - 1 == iGundanID) {
			if (nb6bushouname[i].State <= 2) { // 喼, Rc,  ŃJEg
				list.push_back(i);
			}
		}
	}
	return list;
}

/// (̏u)AVċLɑ݂RćuRcԍyzpzvXgœB
vector<int> getValidGundanList() {
	vector<int> list;

	// Y̑喼hcɑRcXgɉ
	for (int iGundanID = 0; iGundanID < GAMEDATASTRUCT_GUNDAN_NUM; iGundanID++) {
		if (nb6gundan[iGundanID].leader != 0xFFFF) {
			list.push_back(iGundanID);
		}
	}

	return list;
}


// Rcɏ镺𓾂
int getGundanHeisuCnt(int iGundanID) {
	int iSoldierCnt = 0;
	for (int i = 0; i<GAMEDATASTRUCT_BUSHOU_NUM; i++) {
		if (nb6bushou[i].gundan - 1 == iGundanID) {
			if (nb6bushouname[i].State <= 2) { // 喼, Rc,  ŃJEg
				iSoldierCnt += nb6bushou[i].soldier;
			}
		}
	}
	return iSoldierCnt;
}

// Ƃ喼͂̓Rc肠ĔԍXg𓾂B
vector<int> getGovernedGundanWariateNumList(int iDaimyoID) {
	// ȊO͉ꂸɕԂB
	vector<int> list;

	if (0 <= iDaimyoID && iDaimyoID < GAMEDATASTRUCT_DAIMYO_NUM) {

		// Y̑喼hcɑRcXgɉ
		for (int iGundanID = 0; iGundanID<GAMEDATASTRUCT_GUNDAN_NUM; iGundanID++) {
			if (nb6gundan[iGundanID].attach - 1 == iDaimyoID) {
				list.push_back(nb6gundan[iGundanID].number);
			}
		}
	}

	std::sort(list.begin(), list.end());//\[g

	return list;
}



// Ƃ喼žRcɂRcuvԍ̃Xg𓾂B
vector<int> getNotGovernedGundanWariateNumList(int iDaimyoID) {

	// 蓖ĂĂ̂ɁAP
	int wariate_array[8] = { 0,0,0,0,0,0,0,0 };

	if (0 <= iDaimyoID && iDaimyoID < GAMEDATASTRUCT_DAIMYO_NUM) {

		// Y̑喼hcɑRcXgɉ
		for (int iGundanID = 0; iGundanID<GAMEDATASTRUCT_GUNDAN_NUM; iGundanID++) {
			if (nb6gundan[iGundanID].attach - 1 == iDaimyoID) {
				int g = nb6gundan[iGundanID].number;
				if (1 <= g && g <= 8) {
					// 蓖ĂĂ̂ɁAP
					wariate_array[g - 1] = 1;
				}
			}
		}
	}

	vector<int> list;
	for (int ix = 0; ix<8; ix++) {
		if (wariate_array[ix] == 0) { // RcȂ
			list.push_back(ix + 1);
		}
	}

	std::sort(list.begin(), list.end());//\[g

	return list;
}

// RcCԍ̕ύX()݂Bsfalse
bool tryChangeGundanWariateNum(int iGundanID, int iNewWariateNum) {

	// PRc͑喼gBύX͖B
	if (nb6gundan[iGundanID].number == 1) {
		return false;
	}

	if (!(1 <= iNewWariateNum && iNewWariateNum <= 8) ) {
		return false;
	}

	// ̌Rc̑喼ID
	int iDaimyoID = nb6gundan[iGundanID].attach - 1;

	// 喼ŋ󂫃XbgƂȂĂCԍꗗ
	if (0 <= iDaimyoID && iDaimyoID < GAMEDATASTRUCT_DAIMYO_NUM) {
		vector<int> sameDaimyoGundanList = getGovernedGundanList(iDaimyoID);
		int iOldNinmeiNum = nb6gundan[iGundanID].number; // ܂ł̔Cԍ

														 // ʌRcw̌Rc𗘗pĂȂ΁ǍRcԍ̌RcɍグB
		for each (int iGID in sameDaimyoGundanList) {
			// łɕʌRcŗpĂȂ
			if (nb6gundan[iGID].number == iNewWariateNum) {
				nb6gundan[iGID].number = iOldNinmeiNum;
				break;
			}
		}

		// ͎w̌RcԍƂȂB
		nb6gundan[iGundanID].number = iNewWariateNum;

		return true;
	}

	return false;

}


// w̌Rc̏喼𐨗͂zāAύXB
bool setGundanReAttachDaimyo(int iGundanID, int iNewDaimyoID) {

	// V喼ł͂ȂB
	if (!(0 <= iNewDaimyoID && iNewDaimyoID < GAMEDATASTRUCT_DAIMYO_NUM)) {
		return false;
	}

	// RcS܂ĂȂ΁A
	vector<int> glist = getGovernedGundanWariateNumList(iNewDaimyoID);
	if (glist.size() == 8) { // Rc͑S܂Ă
							 // łȂ
		return false;
	}

	if (0 <= iGundanID && iGundanID < GAMEDATASTRUCT_GUNDAN_NUM) {

		// w̌RcݏĂ喼ԍ߂
		int iDaimyoID = nb6gundan[iGundanID].attach - 1;
		// V̑喼AĂ喼ł΁A邱Ƃ͂ȂB
		if (iDaimyoID == iNewDaimyoID) {
			return true;
		}

		// Rc蓖ĔԍPԂ͑喼gB͌ŒB̏ꍇAsƂB
		if (nb6gundan[iGundanID].number == 1) {
			return false;
		}

		// ݁AV喼ɏĂāAnext0xFFFFɂȂĂRcAԂ牺ׂNXg̍ŌゾB
		// Ԃ牺邱Ƃo邩AOɃ`FbNĂB
		int iLinkEndGundanID = -1;
		for (int iCurGundanID = 0; iCurGundanID < GAMEDATASTRUCT_GUNDAN_NUM; iCurGundanID++) {
			// 
			int iCurDaimyoID = nb6gundan[iCurGundanID].attach - 1;

			// w̐V喼ɏĂȂ΁A
			if (iCurDaimyoID == iNewDaimyoID) {
				// ̌Rĉł΁AŏIRcԍ
				if (nb6gundan[iCurGundanID].next == 0xFFFF) {
					iLinkEndGundanID = iCurGundanID + 1;
				}

			}

		}

		// ꂪ͈͂ɓĂȂȂ΁AV喼̌RcNXǵAȂ񂪉ĂB
		// I
		if (!(0 < iLinkEndGundanID && iLinkEndGundanID <= GAMEDATASTRUCT_GUNDAN_NUM)) {
			return false;
		}

		/* @Rc
		
		---

		Ƃ̂

		--

		ƂB
		*/

		int iPrevID = nb6gundan[iGundanID].prev;
		int iNextID = nb6gundan[iGundanID].next;

		// prev͗LȌRcB
		if (0 < iPrevID && iPrevID <= GAMEDATASTRUCT_GUNDAN_NUM) {

			// 擪ł͂ȂRcŁA
			// PǑRc̎̃N悪Rc̏ꍇ
			if (iPrevID != 0xFFFF && nb6gundan[(iPrevID - 1)].next == iGundanID + 1) {
				// Rcł͂ȂǍRcւƌqB
				nb6gundan[(iPrevID - 1)].next = iNextID;
			}
		}

		// next͗LȌRcB
		if (0 < iNextID && iNextID <= GAMEDATASTRUCT_GUNDAN_NUM) {
			// P̌Rc̑ÕN悪Rc̏ꍇ
			if (iNextID != 0xFFFF && nb6gundan[(iNextID - 1)].prev == iGundanID + 1) {
				// Rcł͂ȂAǑRcւƌqB
				nb6gundan[(iNextID - 1)].prev = iPrevID;
			}
		}


		/* @

		-

		Ƃ̂

		--

		ƂB
		*/



		nb6gundan[iLinkEndGundanID - 1].next = iGundanID + 1; // NXg̍Ō̌RcnextRc

		nb6gundan[iGundanID].prev = iLinkEndGundanID; // Rc̑ǑRćARc̃NXg̍Ō̌Rc

													  // RćARcXg̈ԍŌɂBRcnext͋Ȃ
		nb6gundan[iGundanID].next = 0xFFFF; // 

											// 
		{
			nb6gundan[iGundanID].number = 8; // ̔ԍƂ킯ɂ͂Ȃ̂ŁÂ߂ɁAƂ肠Ałmŋ󂢂ĂZ[tȂ̂

			vector<int> milist = getNotGovernedGundanWariateNumList(iNewDaimyoID);
			if (milist.size() > 0) {
				nb6gundan[iGundanID].number = milist[0]; // ԍ̍ŏ̂̂荞
			}

			nb6gundan[iGundanID].attach = iNewDaimyoID + 1;
		}

		for (int iBushouID = 0; iBushouID < GAMEDATASTRUCT_BUSHOU_NUM; iBushouID++) {
			// w̌RcɏĂ镐́ASāAV喼ɏύXB
			if (nb6bushou[iBushouID].gundan == iGundanID + 1) {
				nb6bushou[iBushouID].attach = iNewDaimyoID + 1;
				nb6bushou[iBushouID].work = 0; // mNZbg
				nb6bushou[iBushouID].rise = 0xFFFF; // 惊Zbg
				nb6bushou[iBushouID].bRise = 0; // ԂȂ
				nb6bushou[iBushouID].grudge = 0; // ⍦Ȃ
			}
		}

		return true;

	}

	return false;
}
