#pragma once

#pragma pack(1)

#include <cmath>

// ʂ̂QW^B
struct D2D_POSITION {
	D2D_POSITION(double _x, double _y) : x(_x),y(_y) {}
	D2D_POSITION() : x(0),y(0) {}
	double x;
	double y;


	D2D_POSITION& operator=(const D2D_POSITION& v);
    //rZq
	bool operator==(const D2D_POSITION& v) const;
	bool operator!=(const D2D_POSITION& v) const;
};

// ʂ̂QxNg^B
struct D2D_VECTOR {
	//oϐ
	double x;
	double y;
	//RXgN^
	D2D_VECTOR();
	D2D_VECTOR(double x,double y);
	D2D_VECTOR(D2D_POSITION pos);

	//Zq
	D2D_VECTOR& D2D_VECTOR::operator=(const D2D_VECTOR& v);
	//PZq
	D2D_VECTOR& operator+=(const D2D_VECTOR& v);
	D2D_VECTOR& operator-=(const D2D_VECTOR& v);
	D2D_VECTOR& operator*=(double k);
	D2D_VECTOR& operator/=(double k);
	D2D_VECTOR operator+()const;
	D2D_VECTOR operator-()const;
	//YZq
	double& operator[](int i);
    //rZq
	bool operator==(const D2D_VECTOR& v) const;
	bool operator!=(const D2D_VECTOR& v) const;
	//׃Ng̒
	double length()const;
	//K
	void normalize();
};
//xNgZ
//D2D_VECTOR+D2D_VECTOR
D2D_VECTOR operator+(const D2D_VECTOR& u,const D2D_VECTOR& v);
//D2D_VECTOR-D2D_VECTOR
D2D_VECTOR operator-(const D2D_VECTOR& u,const D2D_VECTOR& v);
//double*D2D_VECTOR
D2D_VECTOR operator*(double k,const  D2D_VECTOR& v);
//D2D_VECTOR*double
D2D_VECTOR operator*(const D2D_VECTOR& v,double k);
//D2D_VECTOR/double
D2D_VECTOR operator/(const D2D_VECTOR& v,double k);
// D2D_VECTOR*D2D_VECTOR
double operator*(const D2D_VECTOR& u,const D2D_VECTOR& v);
//O D2D_VECTOR%D2D_VECTOR
double operator%(const D2D_VECTOR& u,const D2D_VECTOR& v);
//2̃xNĝȂpx
double angle(const D2D_VECTOR& u,const D2D_VECTOR& v);
// Q_ԍW̍
D2D_VECTOR operator-(D2D_POSITION &p1, D2D_POSITION &p2);